﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_linq_find_primes3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Find primes.
        private void btnGo_Click(object sender, EventArgs e)
        {
            int max = int.Parse(txtMax.Text);

            var primes =
                from number in Enumerable.Range(1, max / 2)
                where (
                    (Func<int, bool>)(n =>
                    {
                        for (int i = 3; i * i <= n; i += 2)
                            if (n % i == 0) return false;
                        return true;
                    }
                    )
                )(2 * number + 1)
                select 2 * number + 1;

            // Add the number 2.
            List<int> numbers = primes.ToList();
            numbers.Insert(0, 2);

            // Display the results.
            lstPrimes.DataSource = numbers;
        }
    }
}
